# Generated by Django 3.0.3 on 2021-03-28 16:13

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('relatorios', '0002_cadastrosterritorios_cadastrosusuarias_estadosterritorios_territorioagregado_totaisareasdeuso_totais'),
    ]

    operations = [
        # 1. TotaisGerais
        migrations.RunSQL(
            """
            DROP VIEW IF EXISTS relatorios_totaisgerais;
            CREATE OR REPLACE VIEW relatorios_totaisgerais AS
            SELECT row_number() OVER ()           AS id,
                   sum(a.qtd_territorios)  AS qtd_territorios,
                   sum(a.area_territorios) AS area_territorios,
                   sum(a.qtd_familias)     AS qtd_familias,
                   sum(a.qtd_usuarios)     AS qtd_usuarios,
                   sum(a.qtd_areasdeuso)   AS qtd_areasdeuso,
                   sum(a.qtd_conflitos)    AS qtd_conflitos
            FROM (
                     SELECT count(t.id)                          AS qtd_territorios,
                            sum(st_area(t.poligono::geography)) AS area_territorios,
                            sum(qtde_familias)                   AS qtd_familias,
                            0                                    AS qtd_usuarios,
                            0                                    AS qtd_areasdeuso,
                            0                                    AS qtd_conflitos
                     FROM main_territorio t
                     WHERE t.deleted IS NULL
                     UNION
                     SELECT 0        AS qtd_territorios,
                            0        AS area_territorios,
                            0        AS qtd_familias,
                            count(u) AS qtd_usuarios,
                            0        AS qtd_areasdeuso,
                            0        AS qtd_conflitos
                     FROM usuaria u
                     UNION
                     SELECT 0            AS qtd_territorios,
                            0            AS area_territorios,
                            0            AS qtd_familias,
                            0            AS qtd_usuarios,
                            count(au.id) AS qtd_areasdeuso,
                            0            AS qtd_conflitos
                     FROM main_areadeuso au
                     WHERE au.deleted IS NULL
                     UNION
                     SELECT 0           AS qtd_territorios,
                            0           AS area_territorios,
                            0           AS qtd_familias,
                            0           AS qtd_usuarios,
                            0           AS qtd_areasdeuso,
                            count(c.id) AS qtd_conflitos
                     FROM main_conflito c
                     WHERE c.deleted IS NULL
                 ) a
            """),
    ]
